/* 
 *   Cloak of Darkness - a simple demonstration of Interactive Fiction
 *     This version for TADS written by Dan Shiovitz on 23Sep99
 *       adapted from the version for Inform written by Roger Firth on 17Sep99
 *             4  2003 .
 */
#include <advr.t>
#include <stdr.t>
#include <errorru.t>

modify version
  sdesc = "\( \)\n
             ."
;

modify global
  maxscore = 2
;

modify putVerb
  verb = '' '' ''
;

startroom: room
  sdesc = "  "
  ldesc = "    ,     
            ;    .    
            ,         ."
  south = bar
  west = cloakroom
  north =
  {
    "   , ,   ,  , , 
     . ";
    return nil;
  }
;

cloakroom: room
  sdesc = ""
  ldesc = "   , , -  
             ;     . 
              ."
  east = startroom
;

hook: fixeditem, surface, item
  sdesc = "    " 
  rdesc = "    "
  ddesc = "    "
  vdesc = "    "
  tdesc = "    "
  pdesc = "    "
  noun = '' '' '' '' '' '' '' ''
         '' ''
  adjective = '' '' '' '' ''
              '' '' '' '' ''
              '' ''
  ldesc =
  {
    "    ";
    if (cloak.isIn(self)) 
      "  ,   . ";
    else
      ",   . ";
  }
  location = cloakroom
  isHim = true  
;

bar: darkroom
  lightsOn =
  {
    if (not cloak.isIn(self)) return true;
    else                      return nil;
  }
  sdesc = "  "
  ldesc = ",        
            ,  . ,    
             - ."
  north = startroom
  roomCheck(verb) =
  {
    if (not self.islit)
    {
      if (isclass(verb, travelVerb))
      {
        if (verb <> nVerb)
        {
          "         !";
          message.number += 2;          
          return nil;
        }
      }
      else if (not isclass(verb, sysverb))
      {
        " ?       !";
        message.number += 1;
        return nil;
      }
    }
    return true; 
  }
;

message: fixeditem, readable
  number = 0
  sdesc = " "
  rdesc = " "
  ddesc = " "
  vdesc = " "
  tdesc = " "
  pdesc = " "
  noun = '' '' '' '' ''
         '' '' '' '' '' ''
         '' '' '' '' ''
  adjective = '' '' '' '' ''
              '' '' '' '' '' ''
              ''
  ldesc =
  {
    if (self.number < 2)
    {
      incscore(1);
      "  ,      , ...";
      endGame(true); //    " "   
    }
    else
    {
      "    -  ,   
       .     ...";
      endGame(nil); //    " "   
    }
  }
  location = bar
  isHim = true
;
  
cloak: clothingItem
  sdesc =" "
  rdesc =" "
  ddesc =" "
  vdesc =" "
  tdesc =" "
  pdesc =" "
  noun = '' '' '' '' '' '' '' ''
         '' '' '' '' '' '' ''
  adjective = '' '' '' '' ''
              '' '' '' '' ''
              '' '' '' '' ''
              '' '' '' '' ''
  ldesc = "      , 
           .   ,  ,    ,
             ."
  location = Me
  isHim = true
  isworn = true
  hooked = nil
  doPutOn(actor, iobj) =
  {
    if (iobj = hook and not hooked)
    {
      incscore(1);
      hooked := true;
    }
    pass doPutOn;
  }
  verDoDrop(actor) =
  {
    if (actor.location = cloakroom)
      "    ,     
         ?!";
    else
      "   ,      .";
  }
;

replace init: function
{
  "\b\b     ,   -
       . ,    
    ,         ?..\b\b";
  version.sdesc;
  "\b";
  Me.location := startroom;
  Me.location.lookAround(true);
  Me.location.isseen := true;
  setdaemon(turncount, nil);
  scoreStatus(0,0);
}

endGame: function(won)
{
  "\b";
  if (won)
    "***   ***";
  else
    "***   ***";
  "\b";
  scoreRank();
  "[    ]\n";
  inputkey();
  quit();
}
